-------------------------------------------------------------------------------
--
-- Title       : No Title
-- Design      : filtr_obrazu
-- Author      : Pawe Sokoowski
-- Company     : AGH
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

-------------------------------------------------------------------------------

entity Context_Filter is
	generic(
		DEPTH : INTEGER := 8;
		H_DIM : INTEGER := 256;
		V_DIM : INTEGER := 256
		);
	port(
		CLK : in STD_LOGIC;
		CLR : in STD_LOGIC;
		EN : in STD_LOGIC;
		PIXEL_IN : in STD_LOGIC_VECTOR(7 downto 0);
		PIXEL_OUT : out STD_LOGIC_VECTOR(7 downto 0)
		);
end Context_Filter;	 

-------------------------------------------------------------------------------

architecture Context_Filter of Context_Filter is
	
	---- Component declarations -----
	
	component filter_memory
		generic(
			DEPTH : INTEGER;
			H_DIM : INTEGER;
			V_DIM : INTEGER
			);
		port (
			CLK : in STD_LOGIC;
			CLR : in STD_LOGIC;
			EN : in STD_LOGIC;
			PIXEL_IN : in STD_LOGIC_VECTOR(7 downto 0);
			P_11 : out STD_LOGIC_VECTOR(7 downto 0);
			P_12 : out STD_LOGIC_VECTOR(7 downto 0);
			P_13 : out STD_LOGIC_VECTOR(7 downto 0);
			P_21 : out STD_LOGIC_VECTOR(7 downto 0);
			P_22 : out STD_LOGIC_VECTOR(7 downto 0);
			P_23 : out STD_LOGIC_VECTOR(7 downto 0);
			P_31 : out STD_LOGIC_VECTOR(7 downto 0);
			P_32 : out STD_LOGIC_VECTOR(7 downto 0);
			P_33 : out STD_LOGIC_VECTOR(7 downto 0)
			);
	end component;
	component filter_procedure
		port (
			CLK : in STD_LOGIC;
			EN : in STD_LOGIC;
			P_11 : in STD_LOGIC_VECTOR(7 downto 0);
			P_12 : in STD_LOGIC_VECTOR(7 downto 0);
			P_13 : in STD_LOGIC_VECTOR(7 downto 0);
			P_21 : in STD_LOGIC_VECTOR(7 downto 0);
			P_22 : in STD_LOGIC_VECTOR(7 downto 0);
			P_23 : in STD_LOGIC_VECTOR(7 downto 0);
			P_31 : in STD_LOGIC_VECTOR(7 downto 0);
			P_32 : in STD_LOGIC_VECTOR(7 downto 0);
			P_33 : in STD_LOGIC_VECTOR(7 downto 0);
			PIXEL_OUT : out STD_LOGIC_VECTOR(7 downto 0)
			);
	end component;
	
	---- Signal declarations used on the diagram ----
	
	signal BUS38 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS42 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS46 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS50 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS54 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS58 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS62 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS66 : STD_LOGIC_VECTOR (7 downto 0);
	signal BUS70 : STD_LOGIC_VECTOR (7 downto 0);
	
begin
	
	----  Component instantiations  ----
	
	U1 : filter_memory
	generic map (
		DEPTH => DEPTH,
		H_DIM => H_DIM,
		V_DIM => V_DIM
		)
	port map(
		CLK => CLK,
		CLR => CLR,
		EN => EN,
		PIXEL_IN => PIXEL_IN,
		P_11 => BUS38,
		P_12 => BUS42,
		P_13 => BUS46,
		P_21 => BUS50,
		P_22 => BUS54,
		P_23 => BUS58,
		P_31 => BUS62,
		P_32 => BUS66,
		P_33 => BUS70
		);
	
	U2 : filter_procedure
	port map(
		CLK => CLK,
		EN => EN,
		PIXEL_OUT => PIXEL_OUT,
		P_11 => BUS38,
		P_12 => BUS42,
		P_13 => BUS46,
		P_21 => BUS50,
		P_22 => BUS54,
		P_23 => BUS58,
		P_31 => BUS62,
		P_32 => BUS66,
		P_33 => BUS70
		);
	
	
end Context_Filter;
